<template>
  <b-navbar type="dark" toggleable="md" class="d-print-none" sticky>
    <b-container fluid="xl">
      <!-- topbar menu toggle button here -->
      <b-navbar-toggle target="navbar-menu">
        <span class="navbar-toggler-icon"></span>
      </b-navbar-toggle>
      <!-- topbar logo -->
      <NuxtLink
        to="/"
        class="navbar-brand navbar-brand-autodark d-none-navbar-horizontal pr-0 pr-md-3"
      >
        <img
          src="/logo-white.svg"
          width="128"
          height="40"
          class="navbar-brand-image"
        />
      </NuxtLink>
      <!-- /topbar logo -->
      <!-- topbar right  -->
      <b-navbar-nav v-if="user" class="flex-row">
        <b-nav-item
          id="nav-menu-mosaic"
          class="d-none d-md-flex"
          href="#"
          tabindex="-1"
          @click="clickSiteMap()"
        >
          <LayoutGridIcon class="icon-sm" />
        </b-nav-item>
        <b-nav-item-dropdown
          id="nav-notifications"
          class="d-none d-md-flex"
          href="#"
          tabindex="-1"
          toggle-class="nav-link"
          menu-class="dropdown-menu-card dropdown-menu-notifications"
          right
          no-caret
          @show="markSeenNotifications()"
        >
          <template #button-content>
            <BellIcon class="icon-sm" />
            <span
              v-if="!notificationsSeen"
              class="badge bg-red"
              style="right: 0.82rem"
            ></span>
          </template>
          <NotificationList />
        </b-nav-item-dropdown>
        <b-nav-item
          id="nav-help"
          class="nav-item d-none d-md-flex rimow-hints cursor-pointer"
          tabindex="-1"
          @click="showHints()"
        >
          <HelpIcon class="icon-sm" />
        </b-nav-item>
        <div class="divider-vertical ml-2 mr-3"></div>
        <b-nav-item-dropdown
          data-cy="dropdown-top-bar"
          toggle-class="nav-link d-flex lh-1 text-reset p-0"
          menu-class="dropdown-menu-arrow"
          right
          no-caret
        >
          <template #button-content>
            <Avatar
              size="sm"
              cursor="pointer"
              :img="profile.image || '/avatars/user.jpeg'"
            />
            <div class="d-none d-xl-block pl-2">
              <ChevronDownIcon />
            </div>
          </template>
          <UserMenu />
        </b-nav-item-dropdown>
      </b-navbar-nav>
      <!-- /topbar right  -->
    </b-container>
  </b-navbar>
</template>

<script>
import { mapGetters } from 'vuex';
import introJs from 'intro.js';
import notificationsMixin from '~/mixins/notifications.js';
export default {
  mixins: [notificationsMixin],
  computed: {
    ...mapGetters({
      profile: 'user/profile',
      notificationsSeen: 'notifications/seen',
    }),
    user() {
      return this.$auth.user;
    },
  },
  async beforeMount() {
    if (this.user) {
      await this.$nuxt.context.store.dispatch(
        'notifications/fetchNotifications'
      );
      const result = await this.$nuxt.context.store
        .dispatch('user/getProfileUser')
        .catch(() => {
          this.showErrorNotification('Error getting user profile');
          return null;
        });
      if (result) {
        this.setNotificationsSocket();
      }
    }
  },
  destroyed() {
    if (this.socket) {
      this.socket.emit(
        'leave_room',
        `/notifications/live/${this.$auth.user.sub}`
      );
    }
  },
  methods: {
    clickSiteMap() {
      if (this.$router.currentRoute.path === '/sitemap') {
        this.$router.back();
      } else {
        this.$router.push({
          path: `/sitemap`,
        });
      }
    },
    markSeenNotifications() {
      this.$nuxt.context.store.dispatch('notifications/markAsSeen');
    },
    variantColor(type) {
      switch (type) {
        case 'error':
          return 'danger';
        case 'warning':
          return 'warning';
        case 'success':
          return 'success';
        default:
          return 'info';
      }
    },
    setNotificationsSocket() {
      this.socket = this.$nuxtSocket({
        transports: ['websocket'],
        channel: '/',
      });
      this.socket.on('connect', () => {
        this.socket.emit(
          'join_room',
          `/notifications/live/${this.$auth.user.sub}`
        );
      });
      this.socket.on('job_finished', async (notification) => {
        this.showNotification(
          notification.details,
          notification.title,
          this.variantColor(notification.type),
          notification.url
        );
        await this.$nuxt.context.store.dispatch('user/getUserStats');
        await this.$nuxt.context.store.dispatch('projects/fetchProjects');
        await this.$nuxt.context.store.dispatch('projects/fetchSingleProject', {
          id: notification.projectId,
        });
        delete notification.projectId;
        await this.$nuxt.context.store.dispatch(
          'notifications/addNotificationMenu',
          notification
        );
      });
    },
    showHints() {
      introJs().showHints();
    },
  },
};
</script>
